# -*- coding: utf-8 -*-
#
#  mciaudior.py - a MCIAUDIOR compatible Saori module for ninix
#  Copyright (C) 2003-2009 by Shyouzou Sugitani <shy@users.sourceforge.jp>
#  Copyright (C) 2003 by MATSUMURA Namihiko <nie@counterghost.net>
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License (version 2) as
#  published by the Free Software Foundation.  It is distributed in the
#  hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
#  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
#  PURPOSE.  See the GNU General Public License for more details.
#

# TODO:
# - loop 演奏.

import os
import sys
import signal

from ninix.dll import SAORI


class Saori(SAORI):

    def __init__(self):
        SAORI.__init__(self)
        self.pid = 0
        self.filepath = None
        self.pause = 0

    def finalize(self):
        if self.pid != 0:
            try:
                os.kill(-self.pid, 9)
                os.waitpid(self.pid, 0)
            except:
                pass
	    self.pid = 0
        self.filepath = None
        return 1

    def execute(self, argv):
        argc = len(argv)
        if argc == 1:
            if argv[0] == 'stop':
                ##self.filepath = None
                if self.pid != 0:
                    try:
                        os.kill(-self.pid, 9)
                        os.waitpid(self.pid, 0)
                    except:
                        pass
                    self.pid = 0
            elif argv[0] == 'play':
                if self.pid != 0:
                    status = os.waitpid(-self.pid, os.WNOHANG)
                    if os.WIFEXITED(status) or os.WIFSIGNALED(status):
                        self.pid = 0
                    elif self.pause:
                        os.kill(-self.pid, signal.SIGCONT)
                        self.pause = 0
                        return 'SAORI/1.0 204 No Content\r\n\r\n'
                    else:
                        os.kill(-self.pid, signal.SIGSTOP)
                        self.pause = 1
                        return 'SAORI/1.0 204 No Content\r\n\r\n'
                if os.path.isfile(self.filepath):
                    self.pid = os.fork()
                    if self.pid == 0:
                        os.setsid()
                        for regex, command in self.prefs.get_helpers_regex():
                            if regex.search(self.filepath):
                                self.execute_command(command, self.filepath)
                        os._exit(0)
        elif argc == 2:
            if argv[0] == 'load':
                if self.pid != 0:
                    try:
                        os.kill(-self.pid, 9)
                        os.waitpid(self.pid, 0)
                    except:
                        pass
                    self.pid = 0
                filename = argv[1].replace('\\', '/')
                if not os.path.isabs(filename): # XXX
                    filename = filename.lower()
                self.filepath = os.path.join(self.dir, filename)
        return 'SAORI/1.0 204 No Content\r\n\r\n'

    def execute_command(self, command, arg):
        if '%s' not in command:
            sys.stderr.write('cannot execute command (%s missing)\n')
            return
        os.system(command.replace('%s', arg, 1))
